/************************************************************************
 *									*
 *		qr|QRQbCu				*
 *									*
 *				: qr|QRQb@bgP		*
 *		t@C	: rs1.c					*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include	<stddef.h>
#include	<stdlib.h>
#include	<string.h>
#include	<dos.h>
#include	<conio.h>
#include	"rs232c.h"

/*	[NGA	*/
u_char	rs1_cmdreg;			/* R}hWX^ */
static	int	open_flag;		/* I[vtO */
static	int	duplex;			/* d[h */
static	int	*rbufp;			/* Mobt@|C^ */
static	u_int	rbufsize;		/* Mobt@ */
static	int	alloc_flag;		/* Mobt@AP[VtO */
static	u_int	read_ptr;		/* Mobt@ǂݍ݃|C^ */
static	u_int	write_ptr;		/* Mobt@݃|C^ */
static	u_int	rcv_count;		/* M */
static	int	flow_ctrl;		/* t[ */
static	u_int	flow_off;		/* M҂킹Jnobt@TCY */
static	u_int	flow_on;		/* M҂킹obt@TCY */
static	int	flow_rflag;		/* Mt[tO */
static	int	flow_sflag;		/* Mt[tO */
static	char	*send_buf;		/* Mobt@擪|C^ */
static	char	*send_ptr;		/* Mobt@Jg|C^ */
static	int	send_len;		/* Mf[^ */
static	char	l_pad[10];		/* [fBOpbhf[^ */
static	int	l_pad_size;		/* [fBOpbhf[^ */
static	char	t_pad[10];		/* g[Opbhf[^ */
static	int	t_pad_size;		/* g[Opbhf[^ */
static	int	(*rs1_rcvfunc)(int);	/* [UM荞݊֐|C^ */
static	void	(far interrupt *save_vect)();	/* 荞݃xN^ۑGA */
static	u_int	blt_tbl1[] = {	/* {[[gJE^iPOlgj */
	0x8000, 0x4000, 0x2000, 0x1000, 0x800, 0x400, 0x200, 0x100, 0x80
};
static	u_int	blt_tbl2[] = {	/* {[[gJE^iWlgj */
	0x6800, 0x3400, 0x1a00, 0xd00, 0x680, 0x340, 0x1a0, 0xd0, 0x68
};

/*	֐	*/
static	int	rs1_prmcheck(RSPRM *, u_int *, u_int *);
static	void	interrupt far	rs1_int(void);
static	void	outp2(int, int);

#pragma	check_stack-		/* X^bN`FbN */

/*=======================================================================
 |
 |		qr|QRQbI[v
 |
 |	int	rs1_open(rsprm)
 |
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |
 |		Ԓl			OF
 |					PFI[vς
 |					QF[hp[^G[
 |					RFd[hp[^G[
 |					SF{[[gp[^G[
 |					TFpeB[p[^G[
 |					UFLN^p[^G[
 |					VFXgbvrbgp[^G[
 |					WFt[p[^G[
 |					XFcsqp[^G[
 |					10FMobt@mێs
 |
 =======================================================================*/
int	rs1_open(RSPRM *rsprm)
{
	u_char	far	*fptr;
	union	{
		u_int	i;
		u_char	c[2];
	} cnt;
	u_int	mode, cmd;
	int	err;

	/* I[vς݃`FbN */
	if (open_flag != 0)
		return(1);

	/* I[vp[^`FbN */
	if ((err = rs1_prmcheck(rsprm, &mode, &cmd)) != 0)
		return(err);

	/* Mobt@|C^AMobt@Z[u */
	rbufp = (int *)rsprm->bufp;
	rbufsize = rsprm->buf_size / sizeof(int);

	/* Mobt@m */
	if (rbufp == NULL) {
		if ((rbufp = malloc(rsprm->buf_size)) == NULL)
			return(10);
		alloc_flag = 1;
	} else
		alloc_flag = 0;

	_disable();		/* 荞݋֎~ */

	/* {[[gݒ */
	FP_SEG(fptr) = 0;
	FP_OFF(fptr) = 0x501;
	cnt.i = ((*fptr & 0x80) ? blt_tbl2 : blt_tbl1)[rsprm->blt];
	if (rsprm->sync_mode == ASYNC)
		cnt.i /= 16;
	outp2(IOP_TMC_CWW, 0xb6);
	outp2(IOP_TMC_C2L, cnt.c[0]);
	outp2(IOP_TMC_C2L, cnt.c[1]);

	/* qr|QRQb荞݃}XN */
	outp2(IOP_SYS_WRT, inp(IOP_SYS_RD) & 0xf8);

	/* WQTP`n[hEFAZbg */
	outp2(IOP_RS1_MOD, 0);
	outp2(IOP_RS1_MOD, 0);
	outp2(IOP_RS1_MOD, 0);
	outp2(IOP_RS1_MOD, 0x40);

	/* [hWX^Zbg */
	outp2(IOP_RS1_MOD, mode);

	/* LN^Zbg */
	if (rsprm->sync_mode == SYNC) {
		outp2(IOP_RS1_SYN, rsprm->syn_chr);
		if ((mode & 0x80) == 0)
			outp2(IOP_RS1_SYN, rsprm->syn_chr >> 8);
	}

	/* R}hZbg */
	rs1_cmdreg = cmd;
	outp2(IOP_RS1_MOD, rs1_cmdreg | CMD_ER | CMD_EH);

	/* |C^JE^ */
	read_ptr = write_ptr = rcv_count = 0;

	/* 荞݃xN^ۑ */
	save_vect = _dos_getvect(0x0c);

	/* 荞݃xN^Zbg */
	_dos_setvect(0x0c, rs1_int);

	/* 荞݃}XN */
	outp2(IOP_ICM_IMR, inp(IOP_ICM_IMR) & 0xef);
	outp2(IOP_SYS_SET, 0x01);

	_enable();		/* 荞݋ */

	open_flag = 1;		/* I[vtOZbg */

	return(0);
}

/*=======================================================================
 |
 |		qr|QRQbăI[v
 |
 |	int	rs1_reopen(rsprm)
 |
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |
 |		Ԓl			OF
 |					PFI[v
 |					QF[hp[^G[
 |					RFd[hp[^G[
 |					SF{[[gp[^G[
 |					TFpeB[p[^G[
 |					UFLN^p[^G[
 |					VFXgbvrbgp[^G[
 |					WFt[p[^G[
 |					XFcsqp[^G[
 |
 =======================================================================*/
int	rs1_reopen(RSPRM *rsprm)
{
	u_char	far	*fptr;
	union	{
		u_int	i;
		u_char	c[2];
	} cnt;
	u_int	mode, cmd;
	int	err;
	int	sync1_flag, sync1, sync2_flag, sync2;

	/* I[vς݃`FbN */
	if (open_flag == 0)
		return(1);

	/* I[vp[^`FbN */
	if ((err = rs1_prmcheck(rsprm, &mode, &cmd)) != 0)
		return(err);

	_disable();		/* 荞݋֎~ */

	/* {[[gݒ */
	FP_SEG(fptr) = 0;
	FP_OFF(fptr) = 0x501;
	cnt.i = ((*fptr & 0x80) ? blt_tbl2 : blt_tbl1)[rsprm->blt];
	if (rsprm->sync_mode == ASYNC)
		cnt.i /= 16;
	outp2(IOP_TMC_CWW, 0xb6);
	outp2(IOP_TMC_C2L, cnt.c[0]);
	outp2(IOP_TMC_C2L, cnt.c[1]);

	/* qr|QRQb荞݃}XN */
	outp2(IOP_SYS_WRT, inp(IOP_SYS_RD) & 0xf8);

	/* LN^`FbN */
	sync1_flag = sync2_flag = 0;
	if (rsprm->sync_mode == SYNC) {
		sync1_flag = 1;
		sync1 = rsprm->syn_chr;
		if ((mode & 0x80) == 0) {
			sync2_flag = 1;
			sync2 = rsprm->syn_chr >> 8;
		}
	}

	/* WQTP`n[hEFAZbg */
	outp2(IOP_RS1_MOD, 0x40);

	/* [hWX^Zbg */
	outp2(IOP_RS1_MOD, mode);

	/* LN^Zbg */
	if (sync1_flag) {
		(void)outp(IOP_RS1_SYN, sync1);
		if (sync2_flag)
			(void)outp(IOP_RS1_SYN, sync2);
	}

	/* R}hZbg */
	rs1_cmdreg = cmd;
	(void)outp(IOP_RS1_MOD, rs1_cmdreg | CMD_ER | CMD_EH);

	/* |C^JE^ */
	read_ptr = write_ptr = rcv_count = 0;

	/* 荞݃}XN */
	outp2(IOP_SYS_SET, 0x01);

	_enable();		/* 荞݋ */

	return(0);
}

/*=======================================================================
 |
 |		qr|QRQbI[vp[^`FbN
 |
 |	int	rs1_prmcheck(rsprm, mode, cmd)
 |
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |		u_int	*mode;		WQTP`[h
 |		u_int	*cmd;		WQTP`R}h
 |
 |		Ԓl			OFp[^
 |					QF[hp[^G[
 |					RFd[hp[^G[
 |					SF{[[gp[^G[
 |					TFpeB[p[^G[
 |					UFLN^p[^G[
 |					VFXgbvrbgp[^G[
 |					WFt[p[^G[
 |					XFcsqp[^G[
 |
 =======================================================================*/
static	int	rs1_prmcheck(RSPRM *rsprm, u_int *mode, u_int *cmd)
{
	/* [hAR}h */
	*mode = 0;
	*cmd = 0;

	/* [hp[^`FbN */
	switch (rsprm->sync_mode) {
	case SYNC:		/* [h */
		break;
	case ASYNC:		/* 񓯊[h */
		*mode |= 0x02;
		break;
	default:		/* p[^G[ */
		return(2);
	}

	/* d[hp[^`FbN */
	switch (duplex = rsprm->duplex) {
	case DUPLEX_FULL:	/* Sd */
		*cmd |= CMD_RXE | CMD_TXE | CMD_RTS;
		break;
	case DUPLEX_HALF:	/* d */
		*cmd |= CMD_RXE;
		break;
	default:
		return(3);	/* p[^G[ */
	}

	/* {[[g`FbN */
	if (rsprm->blt < BLT_75 || rsprm->blt > BLT_19200)
		return(4);

	/* peB[`FbN */
	switch (rsprm->parity) {
	case PARITY_NONE:	/* peB[ */
	case PARITY_EVEN:	/* peB[ */
	case PARITY_ODD:	/* peB[ */
		*mode |= rsprm->parity;
		break;
	default:		/* p[^G[ */
		return(5);
	}

	/* LN^`FbN */
	switch (rsprm->chr_len) {
	case CHR_5:		/* Trbg */
	case CHR_6:		/* Urbg */
	case CHR_7:		/* Vrbg */
	case CHR_8:		/* Wrbg */
		*mode |= rsprm->chr_len;
		break;
	default:		/* p[^G[ */
		return(6);
	}

	if (rsprm->sync_mode == ASYNC) {
		/* Xgbvrbg`FbN */
		switch (rsprm->stp_len) {
		case STP_1:	/* Prbg */
		case STP_1_5:	/* PDTrbg */
		case STP_2:	/* Qrbg */
			*mode |= rsprm->stp_len;
			break;
		default:	/* p[^G[ */
			return(7);
		}
	} else {
		/* LN^`FbN */
		if ((rsprm->syn_chr & 0xff00) == 0)
			*mode |= 0x80;
	}

	/* t[`FbN */
	switch (rsprm->flow_ctrl) {
	case FLOW_NONE:		/* t[䖳 */
	case FLOW_SOFT:		/* wnm^wnee */
	case FLOW_HARD:		/* qsr^bsr */
		flow_ctrl = rsprm->flow_ctrl;
		flow_on = rsprm->buf_size / 8;
		flow_off = rsprm->buf_size / 8 * 3;
		flow_rflag = 0;
		flow_sflag = 0;
		break;
	default:		/* p[^G[ */
		return(8);
	}

	/* csq`FbN */
	switch (rsprm->dtr) {
	case DTR_OFF:
		break;
	case DTR_ON:
		*cmd |= CMD_DTR;
		break;
	default:		/* p[^G[ */
		return(9);
	}

	return(0);
}

/*=======================================================================
 |
 |		qr|QRQbN[Y
 |
 |	void	rs1_close()
 |
 =======================================================================*/
void	rs1_close(void)
{
	/* I[vȂ牽Ȃ */
	if (open_flag == 0)
		return;

	_disable();		/* 荞݋֎~ */

	/* n[hEFAZbg */
	outp2(IOP_RS1_MOD, 0);
	outp2(IOP_RS1_MOD, 0);
	outp2(IOP_RS1_MOD, 0);
	outp2(IOP_RS1_MOD, 0x40);

	/* 荞݃}XN */
	outp2(IOP_ICM_IMR, inp(IOP_ICM_IMR) | 0x10);
	outp2(IOP_SYS_WRT, inp(IOP_SYS_RD) & 0xf8);

	/* 荞݃xN^A */
	_dos_setvect(0x0c, save_vect);

	_enable();		/* 荞݋ */

	/* Mobt@mۂꍇ͉ */
	if (alloc_flag != 0)
		free(rbufp);

	rs1_cmdreg = 0;
	open_flag = 0;		/* I[vtOZbg */
}

/*=======================================================================
 |
 |		Mobt@`FbN
 |
 |	int	rs1_rxc()
 |
 |		Ԓl		M
 |
 =======================================================================*/
int	rs1_rxc(void)
{
	return(rcv_count);
}

/*=======================================================================
 |
 |		PM
 |
 |	int	rs1_get()
 |
 |		Ԓl		M
 |
 =======================================================================*/
int	rs1_get(void)
{
	int	c;

	/* M */
	while (rcv_count == 0)
		;

	_disable();		/* 荞݋֎~ */

	/* Po */
	c = rbufp[read_ptr++];
	if (read_ptr == rbufsize)
		read_ptr = 0;
	rcv_count--;

	/* t[ */
	switch (flow_ctrl) {
	case FLOW_SOFT:		/* wnm^wnee */
		if (flow_rflag != 0 && rcv_count < flow_on) {
			outp2(IOP_RS1_DAT, XON);	/* wnmM */
			flow_rflag = 0;
		}
		break;
	case FLOW_HARD:		/* qsr^bsr */
		if (flow_rflag != 0 && rcv_count < flow_on) {
			rs1_cmd(CMD_RTS, CMD_RTS);	/* qsrI */
			flow_rflag = 0;
		}
		break;
	}

	_enable();		/* 荞݋ */

	return(c);
}

/*=======================================================================
 |
 |		Mobt@NA
 |
 |	void	rs1_clear()
 |
 =======================================================================*/
void	rs1_clear(void)
{
	_disable();		/* 荞݋֎~ */

	/* |C^JE^ */
	read_ptr = write_ptr = rcv_count = 0;

	_enable();		/* 荞݋ */
}

/*=======================================================================
 |
 |		PM
 |
 |	void	rs1_put(c)
 |
 |		int	c;		M
 |
 =======================================================================*/
void	rs1_put(int c)
{
	/* t[ɂ鑗M҂킹 */
	while (flow_sflag != 0)
		;

	/* M */
	while ((inp(IOP_RS1_STS) & STS_TXRDY) == 0)
		;

	/* PM */
	outp2(IOP_RS1_DAT, c);
}

/*=======================================================================
 |
 |		ubNM
 |
 |	void	rs1_send(s, len)
 |
 |		char	*s;		M
 |		int	len;		
 |
 =======================================================================*/
void	rs1_send(char *s, int len)
{
	int	i;

	if (len == 0)
		return;

	if (duplex == DUPLEX_HALF) {
		/* MAM֎~AqsrI */
		rs1_cmd(CMD_TXE|CMD_RTS, CMD_TXE|CMD_RXE|CMD_RTS);
	}

	/* [fBOo`cM */
	for (i = 0; i < l_pad_size; i++)
		rs1_put(l_pad[i]);

	/* f[^M */
	while (len--)
		rs1_put(*s++);

	/* g[Oo`cM */
	for (i = 0; i < t_pad_size; i++)
		rs1_put(t_pad[i]);

	if (duplex == DUPLEX_HALF) {
		rs1_cmd(0, CMD_TXE);	/* M֎~ */

		/* MI҂ */
		while ((inp(IOP_RS1_STS) & STS_TXE) == 0)
			;
		/* MAqsrIt */
		rs1_cmd(CMD_RXE, CMD_RXE|CMD_RTS);
	}
}

/*=======================================================================
 |
 |		ubNMv
 |
 |	int	rs1_sendreq(s, len)
 |
 |		char	*s;		M
 |		int	len;		
 |
 |		Ԓl			OF@PFMobt@mێs
 |
 =======================================================================*/
int	rs1_sendreq(char *s, int len)
{
	int	data_size;

	if (len == 0)
		return(0);

	/* ݃f[^MȂ瑗MI܂ő҂ */
	while (send_len != 0)
		;

	/* f[^TCYvZ */
	data_size = l_pad_size + len + t_pad_size;

	/* Mf[^obt@m */
	if ((send_buf = malloc(data_size)) == NULL)
		return(1);

	/* Mf[^obt@Zbg */
	memcpy(send_buf, l_pad, l_pad_size);
	memcpy(send_buf+l_pad_size, s, len);
	memcpy(send_buf+l_pad_size+len, t_pad, t_pad_size);

	/* Mf[^AMf[^obt@|C^Zbg */
	send_len = data_size;
	send_ptr = send_buf;

	if (duplex == DUPLEX_HALF){
		/* MAM֎~AqsrI */
		rs1_cmd(CMD_TXE|CMD_RXE|CMD_RTS, CMD_TXE|CMD_RTS);
	}

	outp2(IOP_SYS_SET, 0x05);	/* M荞݋ */

	return(0);
}

/*=======================================================================
 |
 |		f[^M҂
 |
 |	void	rs1_swait()
 |
 =======================================================================*/
void	rs1_swait(void)
{
	/* ݃f[^MȂ瑗MI܂ő҂ */
	while (send_len != 0)
		;

	/* MI҂ */
	while ((inp(IOP_RS1_STS) & STS_TXE) == 0)
		;
}

/*=======================================================================
 |
 |		t[ݒ
 |
 |	void	rs1_flow(ctrl)
 |
 |		int	ctrl;		t[
 |
 =======================================================================*/
void	rs1_flow(int ctrl)
{
	flow_ctrl = ctrl;
}

/*=======================================================================
 |
 |		o`cݒ
 |
 |	void	rs1_pad(lpad, lpadsize, tpad, tpadsize)
 |
 |		char	*lpad;		[fBOpbhf[^
 |		int	lpad_size;	[fBOpbhf[^
 |		char	*tpad;		g[Opbhf[^
 |		int	tpadsize;	g[Opbhf[^
 |
 =======================================================================*/
void	rs1_pad(char *lpad, int lpadsize, char *tpad, int tpadsize)
{
	memcpy(l_pad, lpad, lpadsize);
	l_pad_size = lpadsize;
	memcpy(t_pad, tpad, tpadsize);
	t_pad_size = tpadsize;
}

/*=======================================================================
 |
 |		M荞ݏݒ
 |
 |	void	rs1_rcvint(func)
 |
 |		int	(*func)();	M荞ݏ
 |
 =======================================================================*/
void	rs1_rcvint(int (*func)(int))
{
	rs1_rcvfunc = func;
}

/*=======================================================================
 |
 |		G^[ng[hZbg
 |
 |	void	rs1_ehm()
 |
 =======================================================================*/
void	rs1_ehm(void)
{
	outp2(IOP_RS1_MOD, rs1_cmdreg | 0x80);
}

/*=======================================================================
 |
 |		crq`FbN
 |
 |	int	rs1_dsr()
 |
 |		Ԓl		OFcrqIt@PFcrqI
 |
 =======================================================================*/
int	rs1_dsr(void)
{
	return(inp(IOP_RS1_STS) & STS_DSR ? 1 : 0);
}

/*=======================================================================
 |
 |		LA`FbN
 |
 |	int	rs1_cd()
 |
 |		Ԓl		OFLAIt@PFLAI
 |
 =======================================================================*/
int	rs1_cd(void)
{
	return(inp(IOP_SYS_SGN) & SGN_CD ? 0 : 1);
}

/*=======================================================================
 |
 |		bsr`FbN
 |
 |	int	rs1_cts()
 |
 |		Ԓl		OFbsrIt@PFbsrI
 |
 =======================================================================*/
int	rs1_cts(void)
{
	return(inp(IOP_SYS_SGN) & SGN_CS ? 0 : 1);
}

/*=======================================================================
 |
 |		bh`FbN
 |
 |	int	rs1_ci()
 |
 |		Ԓl		OFbhIt@PFbhI
 |
 =======================================================================*/
int	rs1_ci(void)
{
	return(inp(IOP_SYS_SGN) & SGN_CI ? 0 : 1);
}

/*=======================================================================
 |
 |		csq
 |
 |	void	rs1_dtr(sw);
 |
 |		int	sw;		OFcsqIt@OFcsqI
 |
 =======================================================================*/
void	rs1_dtr(int sw)
{
	_disable();

	if (sw == 0)
		rs1_cmdreg &= ~CMD_DTR;
	else
		rs1_cmdreg |= CMD_DTR;

	outp2(IOP_RS1_MOD, rs1_cmdreg);

	_enable();
}

/*=======================================================================
 |
 |		qsr
 |
 |	void	rs1_rts(sw);
 |
 |		int	sw;		OFqsrIt@OFqsrI
 |
 =======================================================================*/
void	rs1_rts(int sw)
{
	_disable();

	if (sw == 0)
		rs1_cmdreg &= ~CMD_RTS;
	else
		rs1_cmdreg |= CMD_RTS;

	outp2(IOP_RS1_MOD, rs1_cmdreg);

	_enable();
}

/*=======================================================================
 |
 |		u[NMo
 |
 |	void	rs1_break(sw);
 |
 |		int	sw;		  OFu[NMIt
 |					OFu[NMI
 |
 =======================================================================*/
void	rs1_break(int sw)
{
	_disable();

	if (sw == 0)
		rs1_cmdreg &= ~CMD_SBRK;
	else
		rs1_cmdreg |= CMD_SBRK;

	outp2(IOP_RS1_MOD, rs1_cmdreg);

	_enable();
}

/*=======================================================================
 |
 |		R}ho
 |
 |	void	rs1_cmd(cmd, mask)
 |
 |		int	cmd;		R}h
 |		int	mask;		}XNf[^
 |
 =======================================================================*/
void	rs1_cmd(int cmd, int mask)
{
	_disable();
	rs1_cmdreg = (cmd & mask) | (rs1_cmdreg & ~mask);
	outp2(IOP_RS1_MOD, rs1_cmdreg);
	_enable();
}

/*=======================================================================
 |
 |		Xe[^Xǂݍ
 |
 |	int	rs1_sts()
 |
 |		Ԓl			Xe[^X
 |
 =======================================================================*/
int	rs1_sts(void)
{
	return(inp(IOP_RS1_STS));
}

/*=======================================================================
 |
 |		荞ݏ
 |
 |	void	interrupt far	rs1_int()
 |
 =======================================================================*/
static	void	interrupt far	rs1_int(void)
{
	int	c, sts, sys_flag;

	sts = inp(IOP_RS1_STS);		/* Xe[^Xǂݍ */

	/* M荞ݏ */
	if (sts & STS_RXRDY) {
		/* Mǂݍ */
		c = inp(IOP_RS1_DAT);

		/* Xe[^Xǂݍ */
		if (sts & 0x38) {
			/* G[Zbg */
			outp2(IOP_RS1_MOD, rs1_cmdreg | 0x10);
			c |= (sts & 0x38) << 8;
		}

		/* [UM荞݊֐Ăяo */
		if (rs1_rcvfunc != NULL)
			c = (*rs1_rcvfunc)(c);

		if (c == -1)
			;
		else if (flow_ctrl == FLOW_SOFT && c == XOFF) {
			flow_sflag = 1;
			if (send_len != 0) {
				/* M֎~ */
				outp2(IOP_RS1_MOD, rs1_cmdreg &= ~CMD_TXE);
			}
		} else if (flow_ctrl == FLOW_SOFT && c == XON) {
			flow_sflag = 0;
			if (send_len != 0) {
				/* M */
				outp2(IOP_RS1_MOD, rs1_cmdreg |= CMD_TXE);
			}
		} else if (rcv_count < rbufsize) {
			/* Mobt@ɃZbg */
			rbufp[write_ptr++] = c;

			/* ݃|C^̍XV */
			if (write_ptr == rbufsize)
				write_ptr = 0;

			/* MXV */
			rcv_count++;

			/* t[ */
			switch (flow_ctrl) {
			case FLOW_SOFT:
				if (flow_rflag == 0 && rcv_count > flow_off) {
					/* wneeM */
					if (sts & STS_TXRDY) {
						outp2(IOP_RS1_DAT, XOFF);
						flow_rflag = 1;
					}
				}
				break;
			case FLOW_HARD:
				if (flow_rflag == 0 && rcv_count > flow_off) {
					/* qsrIt */
					outp2(IOP_RS1_MOD, rs1_cmdreg &= ~CMD_RTS);
					flow_rflag = 1;
				}
				break;
			}
		}
	}

	/* dlosx荞ݏ */
	if ((inp(IOP_SYS_RD) & IMR_TXEE) && (sts & STS_TXE)) {
		outp2(IOP_SYS_SET, 0x02);	/* dlosx荞݋֎~ */
		if (duplex == DUPLEX_HALF) {
			/* MAqsrIt */
			rs1_cmdreg = rs1_cmdreg & ~(CMD_RXE|CMD_RTS) | CMD_RXE;
			outp2(IOP_RS1_MOD, rs1_cmdreg);
		}
	}

	/* M荞ݏ */
	if (send_len != 0 && (sts & STS_TXRDY)) {
		outp2(IOP_RS1_DAT, *send_ptr++);		/* ̂PM */
		if (--send_len == 0) {
			if (duplex == DUPLEX_HALF) {
				/* M֎~ */
				outp2(IOP_RS1_MOD, rs1_cmdreg &= ~CMD_TXE);
			}
			outp2(IOP_SYS_SET, 0x04); /* M荞݋֎~ */
			outp2(IOP_SYS_SET, 0x03); /* dlosx荞݋ */
			free(send_buf);		/* Mobt@ */
		}
	}

	/* 荞݃}XN */
	sys_flag = inp(IOP_SYS_RD);
	outp2(IOP_SYS_WRT, sys_flag & 0xf8);

	/* 荞ݏIʒm */
	outp2(IOP_ICM_EOI, 0x20);

	/* 荞݃}XN */
	outp2(0x35, sys_flag);
}

/*=======================================================================
 |
 |		|[g
 |
 |	void	outp2(int port, int databyte)
 |
 |		int	port;		|[gԍ
 |		int	databyte;	o͂l
 |
 =======================================================================*/
static	void	outp2(int port, int databyte)
{
	(void)outp(port, databyte);
}
